/*  Print some primes, using sieve of Eratosthenes.
 *  Version 2.
 *  Author:  Yotam Medini  yotam.medini@gmail.com -- Created: 2007/May/18
 */
#include <stdio.h>
#include <stdlib.h>

extern void show_primes(int* sieve, int N);


int main(int argc, char** argv)
{
    int  rc = 0;
    if (argc != 2) {
        fprintf(stderr, "Usage: %s <limit>\n", argv[0]);
        rc = 1;
    } else {
        int  limit = atoi(argv[1]);
                          /* Get dynamic memory for sieve */
        int*  sieve = (int*)malloc(limit * sizeof(int)); 
        show_primes(sieve, limit);
        free(sieve);      /* Release dynamic memory */
    }
    return rc;    
} /* main */

